Name:           sympa
Version:        6.1.4
Release:        1%{?dist}
Summary:        Mailing list manager

Group:          System Environment/Daemons
License:        GPLv2+
URL:            http://www.sympa.org
Source0:        http://www.sympa.org/distribution/sympa-%{version}.tar.gz
Source1:        sympa-httpd.conf
Source2:        sympa-logrotate.conf
Source3:        sympa-initscript
Source4:        sympa-mail_aliases
Patch0:         sympa-6.1.4-add_staticdir_configure_switch.patch
Patch1:         sympa-6.1.4-move_mailtemplatedir_and_webtemplatedir.patch
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:  gettext
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

Requires:        mod_fcgid
Requires:        perl(CGI)
Requires:        perl(DBD::mysql)
Requires:        perl(FCGI)
Requires:        perl(LWP)
Requires:        perl(Locale::TextDomain)
Requires:        perl(MHonArc::UTF8)

# OPTIONAL modules:
Requires:        perl(AuthCAS)
Requires:        perl(Crypt::CipherSaber)
Requires:        perl(File::NFSLock)
Requires:        perl(IO::Socket::SSL)
Requires:        perl(Mail::DKIM)
Requires:        perl(Net::SMTP)
#Requires:        perl(DBD::Pg)
Requires:        perl(DBD::SQLite)


%description
Sympa is an opensource mailing list manager. It provides a powerful list server
including a lot of features via a web interface.

- high performance for huge lists ( > 700.000 subscribers)
- Mime compatible
- data provisioning using LDAP, SQL or other data sources
- various authentication method (SSO, LDAP, X509)
- benefit of S/MIME and DKIM
- internationalized
- web archive with access control, message removal etc
- multi-domain server designed for service providers.
- sophisticated automatic bounce management
- automatic service message and web interface customizable
- SOAP interface for integration with other applications


%prep
%setup -q
%patch0 -p0
%patch1 -p0

# Fix file encoding
for i in AUTHORS ChangeLog NEWS README; do
        iconv -f iso8859-1 -t utf-8 $i > $i.utf8 && \
        touch -r $i $i.utf8 && \
        mv -f $i.utf8 $i;
done;

# Filter unwanted provides from %%{_datadir}/%%{name}/lib
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
sed -e '/perl(admin)/d' \
    -e '/perl(Archive)/d' \
    -e '/perl(Auth)/d' \
    -e '/perl(Bounce)/d' \
    -e '/perl(Bulk)/d' \
    -e '/perl(Commands)/d' \
    -e '/perl(Conf)/d' \
    -e '/perl(confdef)/d' \
    -e '/perl(Config_XML)/d' \
    -e '/perl(cookielib)/d' \
    -e '/perl(Datasource)/d' \
    -e '/perl(Family)/d' \
    -e '/perl(Fetch)/d' \
    -e '/perl(HTML::myFormatText)/d' \
    -e '/perl(Language)/d' \
    -e '/perl(Ldap)/d' \
    -e '/perl(LDAPSource)/d' \
    -e '/perl(List)/d' \
    -e '/perl(Lock)/d' \
    -e '/perl(Log)/d' \
    -e '/perl(mail)/d' \
    -e '/perl(Marc)/d' \
    -e '/perl(Marc::Search)/d' \
    -e '/perl(Message)/d' \
    -e '/perl(PlainDigest)/d' \
    -e '/perl(report)/d' \
    -e '/perl(Robot)/d' \
    -e '/perl(Scenario)/d' \
    -e '/perl(SharedDocument)/d' \
    -e '/perl(SOAP::Transport::HTTP::FCGI::Sympa)/d' \
    -e '/perl(SOAP::XMLSchema1999::Serializer)/d' \
    -e '/perl(SQLSource)/d' \
    -e '/perl(Sympa::Constants)/d' \
    -e '/perl(SympaSession)/d' \
    -e '/perl(sympasoap)/d' \
    -e '/perl(Sympa::Template::Compat)/d' \
    -e '/perl(Task)/d' \
    -e '/perl(time_utils)/d' \
    -e '/perl(tools)/d' \
    -e '/perl(tt2)/d' \
    -e '/perl(Upgrade)/d' \
    -e '/perl(WebAgent)/d' \
    -e '/perl(wwslib/d' \
EOF

%global __perl_provides %{_builddir}/%{name}-%{version}/%{name}-prov
chmod +x %{__perl_provides}

# Filter unwanted corresponding requires
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
sed -e '/perl(admin)/d' \
    -e '/perl(Archive)/d' \
    -e '/perl(Auth)/d' \
    -e '/perl(Bounce)/d' \
    -e '/perl(Bulk)/d' \
    -e '/perl(Commands)/d' \
    -e '/perl(Conf)/d' \
    -e '/perl(confdef)/d' \
    -e '/perl(Config_XML)/d' \
    -e '/perl(cookielib)/d' \
    -e '/perl(Datasource)/d' \
    -e '/perl(Family)/d' \
    -e '/perl(Fetch)/d' \
    -e '/perl(HTML::myFormatText)/d' \
    -e '/perl(Language)/d' \
    -e '/perl(Ldap)/d' \
    -e '/perl(LDAPSource)/d' \
    -e '/perl(List)/d' \
    -e '/perl(Lock)/d' \
    -e '/perl(Log)/d' \
    -e '/perl(mail)/d' \
    -e '/perl(Marc)/d' \
    -e '/perl(Marc::Search)/d' \
    -e '/perl(Message)/d' \
    -e '/perl(PlainDigest)/d' \
    -e '/perl(report)/d' \
    -e '/perl(Robot)/d' \
    -e '/perl(Scenario)/d' \
    -e '/perl(SharedDocument)/d' \
    -e '/perl(SOAP::Transport::HTTP::FCGI::Sympa)/d' \
    -e '/perl(SOAP::XMLSchema1999::Serializer)/d' \
    -e '/perl(SQLSource)/d' \
    -e '/perl(Sympa::Constants)/d' \
    -e '/perl(SympaSession)/d' \
    -e '/perl(sympasoap)/d' \
    -e '/perl(Sympa::Template::Compat)/d' \
    -e '/perl(SympaTransport)/d' \
    -e '/perl(Task)/d' \
    -e '/perl(time_utils)/d' \
    -e '/perl(tools)/d' \
    -e '/perl(tt2)/d' \
    -e '/perl(Upgrade)/d' \
    -e '/perl(WebAgent)/d' \
    -e '/perl(wwslib/d' \
EOF

%global __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
chmod +x %{__perl_requires}


%build
%configure \
    --enable-fhs \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --docdir=%{_defaultdocdir}/%{name}-%{version} \
    --with-expldir=%{_localstatedir}/lib/%{name}/expl \
    --with-initdir=%{_initrddir} \
    --with-defaultdir=%{_sysconfdir}/%{name}/default \
    --with-staticdir=%{_datadir}/%{name}/static_content

make %{?_smp_mflags}

# Fix manpage encoding after make did all its magic
# Fixing it in the %%prep section doesn't work for some reason
pushd doc/man8
for i in alias_manager.8 archived.8 bounced.8 sympa.8; do
        touch -r $i $i.utf8 && \
        iconv -f iso8859-1 -t utf-8 $i > $i.utf8 && \
        mv -f $i.utf8 $i;
done
popd


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
%find_lang %{name}
%find_lang web_help
cat web_help.lang >> %{name}.lang


# Install http conf
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
sed -e 's.@@libdir@@.%{_libdir}.' %{SOURCE1} > \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/%{name}.conf

# Install logrotate conf
# Note : The conf file is now patched to use the mail facility, so the logrotate conf
#        is now useless.
#install -Dp -m 0644 %{SOURCE2} \
#    $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d/%{name}

# Install initscript
install -Dp -m 0755 %{SOURCE3} $RPM_BUILD_ROOT/%{_initrddir}/%{name}

# Install mail aliases file
install -Dp -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/mail/sympa_aliases

# sendmail secure shell
mkdir -p $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/queue $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/bouncequeue $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_libexecdir}/familyqueue $RPM_BUILD_ROOT/etc/smrsh

# Create bounce and archives directories
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/{arc,bounce}

# Create spool directories
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/%{name}/{msg,bounce,automatic,digest,moderation,topic,auth,outgoing,task,subscribe}

# Autogenerated stuff that needs to be owned by sympa
touch $RPM_BUILD_ROOT%{_datadir}/%{name}/static_content/index.html
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/static_content/{css,pictures}

# Fix perms 
chmod a-x $RPM_BUILD_ROOT%{_datadir}/%{name}/bin/create_db.*

# Tweak sympa.conf
sed -i -e 's/host\.domain\.tld/localhost.localdomain/' \
       -e 's/domain\.tld/localhost.localdomain/' \
       -e 's/your_email_address/root/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/sympa.conf 

# Use the mail facility for sympa logs
sed -i -e 's/^syslog\tLOCAL1/syslog mail/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/sympa.conf
sed -i -e 's/^syslog\tLOCAL1/#syslog mail/' \
       $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/wwsympa.conf


%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group sympa >/dev/null || groupadd -r sympa
getent passwd sympa >/dev/null || \
useradd -r -g sympa -d /var/lib/sympa -s /sbin/nologin \
        -c "User for the sympa mailing list manager" sympa
exit 0


%post
/sbin/chkconfig --add %{name}


%preun
if [ $1 = 0 ] ; then
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi


%postun
### FIXME: we probably want to also run '/usr/sbin/sympa.pl --upgrade' here
if [ "$1" -ge "1" ] ; then
    /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING doc/sample INSTALL NEWS README README.charset
%{_mandir}/man8/*.8.*
%{_initrddir}/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
#%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/mail/sympa_aliases
%{_sysconfdir}/smrsh/*

%dir %{_sysconfdir}/%{name}
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/data_structure.version
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/sympa.conf
%config(noreplace) %attr(-,sympa,root) %{_sysconfdir}/%{name}/wwsympa.conf
%dir %{_sysconfdir}/%{name}/default
%config(noreplace) %{_sysconfdir}/%{name}/default/*.conf
%config(noreplace) %{_sysconfdir}/%{name}/default/ca-bundle.crt
%config(noreplace) %{_sysconfdir}/%{name}/default/*.tt2
%config(noreplace) %{_sysconfdir}/%{name}/default/mime.types
%config(noreplace) %{_sysconfdir}/%{name}/default/sympa.wsdl
%dir %{_sysconfdir}/%{name}/default/create_list_templates
%dir %{_sysconfdir}/%{name}/default/create_list_templates/discussion_list
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/discussion_list/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/hotline
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/hotline/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/html-news-letter
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/html-news-letter/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/intranet_list
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/intranet_list/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/news-letter
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/news-letter/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/private_working_group
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/private_working_group/*
%dir %{_sysconfdir}/%{name}/default/create_list_templates/public_web_forum
%config(noreplace) %{_sysconfdir}/%{name}/default/create_list_templates/public_web_forum/*
%dir %{_sysconfdir}/%{name}/default/families
%dir %{_sysconfdir}/%{name}/default/families/sample-auto
%config(noreplace) %{_sysconfdir}/%{name}/default/families/sample-auto/*
%dir %{_sysconfdir}/%{name}/default/global_task_models
%config(noreplace) %{_sysconfdir}/%{name}/default/global_task_models/*.task
%dir %{_sysconfdir}/%{name}/default/list_task_models
%config(noreplace) %{_sysconfdir}/%{name}/default/list_task_models/*.task
%dir %{_sysconfdir}/%{name}/default/scenari
%config(noreplace) %{_sysconfdir}/%{name}/default/scenari/*
%dir %{_sysconfdir}/%{name}/default/mail_tt2
%config(noreplace) %{_sysconfdir}/%{name}/default/mail_tt2/*
%dir %{_sysconfdir}/%{name}/default/web_tt2
%config(noreplace) %{_sysconfdir}/%{name}/default/web_tt2/*

%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/cgi
%{_libdir}/%{name}/cgi/sympa_soap_server.fcgi
%attr(4755,sympa,root) %{_libdir}/%{name}/cgi/sympa_soap_server-wrapper.fcgi
%{_libdir}/%{name}/cgi/wwsympa.fcgi
%attr(4755,sympa,root) %{_libdir}/%{name}/cgi/wwsympa-wrapper.fcgi
%attr(4755,sympa,sympa) %{_libexecdir}/bouncequeue
%attr(4755,sympa,sympa) %{_libexecdir}/familyqueue
%attr(4755,sympa,sympa) %{_libexecdir}/queue
%attr(4750,root,sympa) %{_sbindir}/aliaswrapper
%attr(4750,root,sympa) %{_sbindir}/virtualwrapper
%{_sbindir}/alias_manager.pl
%{_sbindir}/archived.pl
%{_sbindir}/bounced.pl
%{_sbindir}/bulk.pl
%{_sbindir}/sympa.pl
%{_sbindir}/sympa_wizard.pl
%{_sbindir}/task_manager.pl

%dir %{_datadir}/%{name}
%{_datadir}/%{name}/bin
%{_datadir}/%{name}/lib
%dir %{_datadir}/%{name}/static_content
%{_datadir}/%{name}/static_content/icons
%attr(-,sympa,root) %{_datadir}/%{name}/static_content/index.html
%dir %attr(-,sympa,root) %{_datadir}/%{name}/static_content/css
%dir %attr(-,sympa,root) %{_datadir}/%{name}/static_content/pictures
%attr(-,sympa,root) %{_localstatedir}/lib/%{name}
%attr(-,sympa,root) %{_localstatedir}/spool/%{name}


%changelog
* Thu May 12 2011 Xavier Bachelot <xavier@bachelot.org> 6.1.4-1
- Initial Fedora release.
